// TJC implementation of procedure parseproc_args_ok
package tjc;
import tcl.lang.*;

public class ParseprocArgsOkCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 11, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        ExprValue evs3 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "argstr");
        }
        setVarScalar(interp, "argstr", objv[1], compiledLocals, 0);
        { // Invoke: set first [...]
            TclObject tmp0;
            { // Invoke: string index $argstr 0
                TclObject tmp1 = getVarScalar(interp, "argstr", compiledLocals, 0);
                String tmp2 = tmp1.toString();
                TclObject tmp3 = TJC.stringIndex(interp, tmp2, const0);
                interp.setResult(tmp3);
            } // End Invoke: string
            tmp0 = interp.getResult();
            setVarScalar(interp, "first", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set last [...]
            TclObject tmp4;
            { // Invoke: string index $argstr end
                TclObject tmp5 = getVarScalar(interp, "argstr", compiledLocals, 0);
                String tmp6 = tmp5.toString();
                TclObject tmp7 = TJC.stringIndex(interp, tmp6, const1);
                interp.setResult(tmp7);
            } // End Invoke: string
            tmp4 = interp.getResult();
            setVarScalar(interp, "last", tmp4, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Binary operator: () && ()
            // Binary operator: $first == "\""
            TclObject tmp8 = getVarScalar(interp, "first", compiledLocals, 1);
            boolean tmp9 = tmp8.toString().equals("\"");
            ExprValue tmp10 = evs0;
            tmp10.setIntValue(tmp9);
            // End Binary operator: ==
            if (tmp10.getBooleanValue(interp)) {
            // Binary operator: $last != "\""
            TclObject tmp11 = getVarScalar(interp, "last", compiledLocals, 2);
            boolean tmp12 = ! tmp11.toString().equals("\"");
            ExprValue tmp13 = evs1;
            tmp13.setIntValue(tmp12);
            // End Binary operator: !=
            tmp10.setIntValue(tmp13.getBooleanValue(interp));
            } else {
            tmp10.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            if (!tmp10.getBooleanValue(interp)) {
            // Binary operator: () && ()
            // Binary operator: $last == "\""
            TclObject tmp14 = getVarScalar(interp, "last", compiledLocals, 2);
            boolean tmp15 = tmp14.toString().equals("\"");
            ExprValue tmp16 = evs1;
            tmp16.setIntValue(tmp15);
            // End Binary operator: ==
            if (tmp16.getBooleanValue(interp)) {
            // Binary operator: $first != "\""
            TclObject tmp17 = getVarScalar(interp, "first", compiledLocals, 1);
            boolean tmp18 = ! tmp17.toString().equals("\"");
            ExprValue tmp19 = evs2;
            tmp19.setIntValue(tmp18);
            // End Binary operator: !=
            tmp16.setIntValue(tmp19.getBooleanValue(interp));
            } else {
            tmp16.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            tmp10.setIntValue(tmp16.getBooleanValue(interp));
            } else {
            tmp10.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp20 = ( tmp10.getIntValue() != 0 );
            if ( tmp20 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Binary operator: () && ()
            // Binary operator: $first == "{"
            TclObject tmp21 = getVarScalar(interp, "first", compiledLocals, 1);
            boolean tmp22 = tmp21.toString().equals("{");
            ExprValue tmp23 = evs0;
            tmp23.setIntValue(tmp22);
            // End Binary operator: ==
            if (tmp23.getBooleanValue(interp)) {
            // Binary operator: $last != "}"
            TclObject tmp24 = getVarScalar(interp, "last", compiledLocals, 2);
            boolean tmp25 = ! tmp24.toString().equals("}");
            ExprValue tmp26 = evs1;
            tmp26.setIntValue(tmp25);
            // End Binary operator: !=
            tmp23.setIntValue(tmp26.getBooleanValue(interp));
            } else {
            tmp23.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            if (!tmp23.getBooleanValue(interp)) {
            // Binary operator: () && ()
            // Binary operator: $last == "}"
            TclObject tmp27 = getVarScalar(interp, "last", compiledLocals, 2);
            boolean tmp28 = tmp27.toString().equals("}");
            ExprValue tmp29 = evs1;
            tmp29.setIntValue(tmp28);
            // End Binary operator: ==
            if (tmp29.getBooleanValue(interp)) {
            // Binary operator: $first != "{"
            TclObject tmp30 = getVarScalar(interp, "first", compiledLocals, 1);
            boolean tmp31 = ! tmp30.toString().equals("{");
            ExprValue tmp32 = evs2;
            tmp32.setIntValue(tmp31);
            // End Binary operator: !=
            tmp29.setIntValue(tmp32.getBooleanValue(interp));
            } else {
            tmp29.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            tmp23.setIntValue(tmp29.getBooleanValue(interp));
            } else {
            tmp23.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp33 = ( tmp23.getIntValue() != 0 );
            if ( tmp33 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ... else ...
            // Binary operator: () && ()
            // Binary operator: $first != "\""
            TclObject tmp34 = getVarScalar(interp, "first", compiledLocals, 1);
            boolean tmp35 = ! tmp34.toString().equals("\"");
            ExprValue tmp36 = evs0;
            tmp36.setIntValue(tmp35);
            // End Binary operator: !=
            if (tmp36.getBooleanValue(interp)) {
            // Binary operator: $first != "{"
            TclObject tmp37 = getVarScalar(interp, "first", compiledLocals, 1);
            boolean tmp38 = ! tmp37.toString().equals("{");
            ExprValue tmp39 = evs1;
            tmp39.setIntValue(tmp38);
            // End Binary operator: !=
            tmp36.setIntValue(tmp39.getBooleanValue(interp));
            } else {
            tmp36.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp40 = ( tmp36.getIntValue() != 0 );
            if ( tmp40 ) {
                { // Invoke: if ... ...
                    // Binary operator: [...] != ()
                    { // Invoke: string first " " $argstr
                        char tmp41 = ' ';
                        TclObject tmp42 = getVarScalar(interp, "argstr", compiledLocals, 0);
                        String tmp43 = tmp42.toString();
                        int tmp44 = tmp43.indexOf(tmp41);
                        interp.setResult(tmp44);
                    } // End Invoke: string
                    TclObject tmp45 = interp.getResult();
                    ExprValue tmp46 = evs0;
                    TJC.exprInitValue(interp, tmp46, tmp45);
                    // Unary operator: - 1
                    ExprValue tmp47 = evs1;
                    tmp47.setIntValue(-1);
                    // End Unary operator: -
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp46, tmp47);
                    // End Binary operator: !=
                    boolean tmp48 = ( tmp46.getIntValue() != 0 );
                    if ( tmp48 ) {
                        { // Invoke: return 0
                            interp.resetResult();
                            interp.setResult(const0);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
                { // Invoke: set naked $argstr
                    TclObject tmp49;
                    tmp49 = getVarScalar(interp, "argstr", compiledLocals, 0);
                    setVarScalar(interp, "naked", tmp49, compiledLocals, 3);
                } // End Invoke: set
            } else {
                { // Invoke: set naked [...]
                    TclObject tmp50;
                    { // Invoke: string range $argstr 1 end-1
                        TclObject tmp51 = getVarScalar(interp, "argstr", compiledLocals, 0);
                        String tmp52 = tmp51.toString();
                        TclObject tmp53 = const2;
                        tmp53.preserve();
                        TclObject tmp54 = const3;
                        TclObject tmp55 = TJC.stringRange(interp, tmp52, tmp53, tmp54);
                        interp.setResult(tmp55);
                    } // End Invoke: string
                    tmp50 = interp.getResult();
                    setVarScalar(interp, "naked", tmp50, compiledLocals, 3);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: [...] != ()
            { // Invoke: string first ... $naked
                char tmp56 = '$';
                TclObject tmp57 = getVarScalar(interp, "naked", compiledLocals, 3);
                String tmp58 = tmp57.toString();
                int tmp59 = tmp58.indexOf(tmp56);
                interp.setResult(tmp59);
            } // End Invoke: string
            TclObject tmp60 = interp.getResult();
            ExprValue tmp61 = evs0;
            TJC.exprInitValue(interp, tmp61, tmp60);
            // Unary operator: - 1
            ExprValue tmp62 = evs1;
            tmp62.setIntValue(-1);
            // End Unary operator: -
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp61, tmp62);
            // End Binary operator: !=
            boolean tmp63 = ( tmp61.getIntValue() != 0 );
            if ( tmp63 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: [...] != ()
            { // Invoke: string first ... $naked
                char tmp64 = '[';
                TclObject tmp65 = getVarScalar(interp, "naked", compiledLocals, 3);
                String tmp66 = tmp65.toString();
                int tmp67 = tmp66.indexOf(tmp64);
                interp.setResult(tmp67);
            } // End Invoke: string
            TclObject tmp68 = interp.getResult();
            ExprValue tmp69 = evs0;
            TJC.exprInitValue(interp, tmp69, tmp68);
            // Unary operator: - 1
            ExprValue tmp70 = evs1;
            tmp70.setIntValue(-1);
            // End Unary operator: -
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp69, tmp70);
            // End Binary operator: !=
            boolean tmp71 = ( tmp69.getIntValue() != 0 );
            if ( tmp71 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: [...] != ()
            { // Invoke: string first ... $naked
                char tmp72 = ']';
                TclObject tmp73 = getVarScalar(interp, "naked", compiledLocals, 3);
                String tmp74 = tmp73.toString();
                int tmp75 = tmp74.indexOf(tmp72);
                interp.setResult(tmp75);
            } // End Invoke: string
            TclObject tmp76 = interp.getResult();
            ExprValue tmp77 = evs0;
            TJC.exprInitValue(interp, tmp77, tmp76);
            // Unary operator: - 1
            ExprValue tmp78 = evs1;
            tmp78.setIntValue(-1);
            // End Unary operator: -
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp77, tmp78);
            // End Binary operator: !=
            boolean tmp79 = ( tmp77.getIntValue() != 0 );
            if ( tmp79 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set arg_list $naked
            TclObject tmp80;
            tmp80 = getVarScalar(interp, "naked", compiledLocals, 3);
            setVarScalar(interp, "arg_list", tmp80, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set len [...]
            TclObject tmp81;
            { // Invoke: llength $arg_list
                TclObject tmp82 = getVarScalar(interp, "arg_list", compiledLocals, 4);
                int tmp83 = TclList.getLength(interp, tmp82);
                interp.setResult(tmp83);
            } // End Invoke: llength
            tmp81 = interp.getResult();
            setVarScalar(interp, "len", tmp81, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set i 0
            setVarScalar(interp, "i", const0, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set found_default 0
            setVarScalar(interp, "found_default", const0, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: foreach arg $arg_list ...
            TclObject tmp84 = null;
            try {
                tmp84 = getVarScalar(interp, "arg_list", compiledLocals, 4);
                tmp84.preserve();
                final int tmp84_length = TclList.getLength(interp, tmp84);

                for ( int index85 = 0 ; index85 < tmp84_length ; index85++ ) {
                    TclObject tmp86 = TclList.index(interp, tmp84, index85);
                    try {
                        setVarScalar(interp, "arg", tmp86, compiledLocals, 8);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "arg");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if {[llength $arg] > 2} ...
                        // Binary operator: [...] > 2
                        { // Invoke: llength $arg
                            TclObject tmp87 = getVarScalar(interp, "arg", compiledLocals, 8);
                            int tmp88 = TclList.getLength(interp, tmp87);
                            interp.setResult(tmp88);
                        } // End Invoke: llength
                        TclObject tmp89 = interp.getResult();
                        ExprValue tmp90 = evs0;
                        TJC.exprInitValue(interp, tmp90, tmp89);
                        ExprValue tmp91 = evs1;
                        tmp91.setIntValue(2);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp90, tmp91);
                        // End Binary operator: >
                        boolean tmp92 = ( tmp90.getIntValue() != 0 );
                        if ( tmp92 ) {
                            { // Invoke: return 0
                                interp.resetResult();
                                interp.setResult(const0);
                                if ( true ) { return; }
                            } // End Invoke: return
                        }
                    } // End Invoke: if
                    { // Invoke: if ... ... else ...
                        // Binary operator: [...] == 1
                        { // Invoke: llength $arg
                            TclObject tmp93 = getVarScalar(interp, "arg", compiledLocals, 8);
                            int tmp94 = TclList.getLength(interp, tmp93);
                            interp.setResult(tmp94);
                        } // End Invoke: llength
                        TclObject tmp95 = interp.getResult();
                        ExprValue tmp96 = evs0;
                        TJC.exprInitValue(interp, tmp96, tmp95);
                        ExprValue tmp97 = evs1;
                        tmp97.setIntValue(1);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp96, tmp97);
                        // End Binary operator: ==
                        boolean tmp98 = ( tmp96.getIntValue() != 0 );
                        if ( tmp98 ) {
                            { // Invoke: if ... ...
                                // Binary operator: () && ()
                                // Binary operator: $arg == "args"
                                TclObject tmp99 = getVarScalar(interp, "arg", compiledLocals, 8);
                                boolean tmp100 = tmp99.toString().equals("args");
                                ExprValue tmp101 = evs0;
                                tmp101.setIntValue(tmp100);
                                // End Binary operator: ==
                                if (tmp101.getBooleanValue(interp)) {
                                // Binary operator: $i != ()
                                TclObject tmp102 = getVarScalar(interp, "i", compiledLocals, 6);
                                ExprValue tmp103 = evs1;
                                TJC.exprInitValue(interp, tmp103, tmp102);
                                // Binary operator: $len - 1
                                TclObject tmp104 = getVarScalar(interp, "len", compiledLocals, 5);
                                ExprValue tmp105 = evs2;
                                TJC.exprInitValue(interp, tmp105, tmp104);
                                ExprValue tmp106 = evs3;
                                tmp106.setIntValue(1);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp105, tmp106);
                                // End Binary operator: -
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp103, tmp105);
                                // End Binary operator: !=
                                tmp101.setIntValue(tmp103.getBooleanValue(interp));
                                } else {
                                tmp101.setIntValue(0);
                                } // End if: ()
                                // End Binary operator: &&
                                boolean tmp107 = ( tmp101.getIntValue() != 0 );
                                if ( tmp107 ) {
                                    { // Invoke: return 0
                                        interp.resetResult();
                                        interp.setResult(const0);
                                        if ( true ) { return; }
                                    } // End Invoke: return
                                }
                            } // End Invoke: if
                            { // Invoke: if ... ...
                                // Binary operator: () && $found_default
                                // Binary operator: $arg != "args"
                                TclObject tmp108 = getVarScalar(interp, "arg", compiledLocals, 8);
                                boolean tmp109 = ! tmp108.toString().equals("args");
                                ExprValue tmp110 = evs0;
                                tmp110.setIntValue(tmp109);
                                // End Binary operator: !=
                                if (tmp110.getBooleanValue(interp)) {
                                TclObject tmp111 = getVarScalar(interp, "found_default", compiledLocals, 7);
                                ExprValue tmp112 = evs1;
                                TJC.exprInitValue(interp, tmp112, tmp111);
                                tmp110.setIntValue(tmp112.getBooleanValue(interp));
                                } else {
                                tmp110.setIntValue(0);
                                } // End if: ()
                                // End Binary operator: &&
                                boolean tmp113 = ( tmp110.getIntValue() != 0 );
                                if ( tmp113 ) {
                                    { // Invoke: return 0
                                        interp.resetResult();
                                        interp.setResult(const0);
                                        if ( true ) { return; }
                                    } // End Invoke: return
                                }
                            } // End Invoke: if
                        } else {
                            { // Invoke: set name [...]
                                TclObject tmp114;
                                { // Invoke: lindex $arg 0
                                    TclObject tmp115 = getVarScalar(interp, "arg", compiledLocals, 8);
                                    tmp115 = TclList.index(interp, tmp115, 0);
                                    if ( tmp115 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp115);
                                    }
                                } // End Invoke: lindex
                                tmp114 = interp.getResult();
                                setVarScalar(interp, "name", tmp114, compiledLocals, 9);
                            } // End Invoke: set
                            { // Invoke: set def [...]
                                TclObject tmp116;
                                { // Invoke: lindex $arg 1
                                    TclObject tmp117 = getVarScalar(interp, "arg", compiledLocals, 8);
                                    tmp117 = TclList.index(interp, tmp117, 1);
                                    if ( tmp117 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp117);
                                    }
                                } // End Invoke: lindex
                                tmp116 = interp.getResult();
                                setVarScalar(interp, "def", tmp116, compiledLocals, 10);
                            } // End Invoke: set
                            { // Invoke: if {$name == "args"} ...
                                // Binary operator: $name == "args"
                                TclObject tmp118 = getVarScalar(interp, "name", compiledLocals, 9);
                                boolean tmp119 = tmp118.toString().equals("args");
                                ExprValue tmp120 = evs0;
                                tmp120.setIntValue(tmp119);
                                // End Binary operator: ==
                                boolean tmp121 = ( tmp120.getIntValue() != 0 );
                                if ( tmp121 ) {
                                    { // Invoke: return 0
                                        interp.resetResult();
                                        interp.setResult(const0);
                                        if ( true ) { return; }
                                    } // End Invoke: return
                                }
                            } // End Invoke: if
                            { // Invoke: set found_default 1
                                setVarScalar(interp, "found_default", const2, compiledLocals, 7);
                            } // End Invoke: set
                        }
                    } // End Invoke: if
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 6);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp84 != null ) {
                    tmp84.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: return 1
            interp.resetResult();
            interp.setResult(const2);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parseproc_args_ok");
        } finally {
            TJC.exprReleaseValue(interp, evs3);
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("end");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(1);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("end-1");
        const3.preserve(); const3.preserve();
    }

    String[] compiledLocalsNames = {
        "argstr",
        "first",
        "last",
        "naked",
        "arg_list",
        "len",
        "i",
        "found_default",
        "arg",
        "name",
        "def"
    };
} // end class ParseprocArgsOkCmd

