

module example1 ( in1, in2, out1 );
parameter N1 = 4;
parameter N2 = N1 + 1;
input [N2:0]in1, in2;
output [0:N2]out1;
	mid mid_in_top_inst1(in1[0], in2[0], out1[0]);
endmodule

module mid( a, b, z );
	input  a;
	input  b;
	output  z;
	bottom bot_in_mid_inst1(a, b, z);
endmodule

module bottom( i1, i2, o1 );
	input i1, i2;
	output o1;
	reg o1;
	wire w1 = 1'b1;
	always @( i1 or i2 )
		o1 = i1 ? i1 : i2;
endmodule
