// TJC implementation of procedure _parseproc_append_outscript_including
package tjc;
import tcl.lang.*;

public class ParseprocAppendOutscriptIncludingCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 12, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "script range");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "range", objv[2], compiledLocals, 1);
        { // Invoke: global _parseproc
            TJC.makeGlobalLinkVar(interp, "_parseproc", "_parseproc", 2);
        } // End Invoke: global
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if {$debug} ...
            TclObject tmp0 = getVarScalar(interp, "debug", compiledLocals, 3);
            boolean tmp1 = TJC.getBoolean(interp, tmp0);
            if ( tmp1 ) {
                { // Invoke: puts "..."
                    TclObject[] objv2 = TJC.grabObjv(interp, 2);
                    TclObject tmp3;
                    try {
                        // Arg 0 constant: puts
                        objv2[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp4 = new StringBuffer(64);
                        sbtmp4.append("_parseproc_append_outscript_including ");
                        sbtmp4.append("{");
                        tmp3 = getVarScalar(interp, "range", compiledLocals, 1);
                        sbtmp4.append(tmp3.toString());
                        sbtmp4.append("}");
                        tmp3 = TclString.newInstance(sbtmp4);
                        tmp3.preserve();
                        objv2[1] = tmp3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp3 = objv2[1];
                        if ( tmp3 != null ) {
                            tmp3.release();
                        }
                        TJC.releaseObjv(interp, objv2, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: set inscript $script
            TclObject tmp5;
            tmp5 = getVarScalar(interp, "script", compiledLocals, 0);
            setVarScalar(interp, "inscript", tmp5, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set inscript_start [...]
            TclObject tmp6;
            { // Invoke: lindex $... 0
                TclObject tmp7 = getVarArray(interp, "_parseproc", "inscript_range", compiledLocals, 2);
                tmp7 = TclList.index(interp, tmp7, 0);
                if ( tmp7 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp7);
                }
            } // End Invoke: lindex
            tmp6 = interp.getResult();
            setVarScalar(interp, "inscript_start", tmp6, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $inscript_start != 0
            TclObject tmp8 = getVarScalar(interp, "inscript_start", compiledLocals, 5);
            ExprValue tmp9 = evs0;
            TJC.exprInitValue(interp, tmp9, tmp8);
            ExprValue tmp10 = evs1;
            tmp10.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp9, tmp10);
            // End Binary operator: !=
            boolean tmp11 = ( tmp9.getIntValue() != 0 );
            if ( tmp11 ) {
                { // Invoke: error "..."
                    TclObject[] objv12 = TJC.grabObjv(interp, 2);
                    TclObject tmp13;
                    try {
                        // Arg 0 constant: error
                        objv12[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp14 = new StringBuffer(64);
                        sbtmp14.append("expected inscript_start to be 0, got ");
                        tmp13 = getVarScalar(interp, "inscript_start", compiledLocals, 5);
                        sbtmp14.append(tmp13.toString());
                        tmp13 = TclString.newInstance(sbtmp14);
                        tmp13.preserve();
                        objv12[1] = tmp13;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv12, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp13 = objv12[1];
                        if ( tmp13 != null ) {
                            tmp13.release();
                        }
                        TJC.releaseObjv(interp, objv12, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set inscript_len [...]
            TclObject tmp15;
            { // Invoke: lindex $... 1
                TclObject tmp16 = getVarArray(interp, "_parseproc", "inscript_range", compiledLocals, 2);
                tmp16 = TclList.index(interp, tmp16, 1);
                if ( tmp16 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp16);
                }
            } // End Invoke: lindex
            tmp15 = interp.getResult();
            setVarScalar(interp, "inscript_len", tmp15, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set range_start [...]
            TclObject tmp17;
            { // Invoke: lindex $range 0
                TclObject tmp18 = getVarScalar(interp, "range", compiledLocals, 1);
                tmp18 = TclList.index(interp, tmp18, 0);
                if ( tmp18 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp18);
                }
            } // End Invoke: lindex
            tmp17 = interp.getResult();
            setVarScalar(interp, "range_start", tmp17, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set range_len [...]
            TclObject tmp19;
            { // Invoke: lindex $range 1
                TclObject tmp20 = getVarScalar(interp, "range", compiledLocals, 1);
                tmp20 = TclList.index(interp, tmp20, 1);
                if ( tmp20 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp20);
                }
            } // End Invoke: lindex
            tmp19 = interp.getResult();
            setVarScalar(interp, "range_len", tmp19, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set before_len [...]
            TclObject tmp21;
            { // Invoke: expr ...
                // Binary operator: () - $inscript_len
                // Binary operator: $range_start + $range_len
                TclObject tmp22 = getVarScalar(interp, "range_start", compiledLocals, 7);
                ExprValue tmp23 = evs0;
                TJC.exprInitValue(interp, tmp23, tmp22);
                TclObject tmp24 = getVarScalar(interp, "range_len", compiledLocals, 8);
                ExprValue tmp25 = evs1;
                TJC.exprInitValue(interp, tmp25, tmp24);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp23, tmp25);
                // End Binary operator: +
                TclObject tmp26 = getVarScalar(interp, "inscript_len", compiledLocals, 6);
                ExprValue tmp27 = evs1;
                TJC.exprInitValue(interp, tmp27, tmp26);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp23, tmp27);
                // End Binary operator: -
                TJC.exprSetResult(interp, tmp23);
            } // End Invoke: expr
            tmp21 = interp.getResult();
            setVarScalar(interp, "before_len", tmp21, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: if {$before_len > 0} ...
            // Binary operator: $before_len > 0
            TclObject tmp28 = getVarScalar(interp, "before_len", compiledLocals, 9);
            ExprValue tmp29 = evs0;
            TJC.exprInitValue(interp, tmp29, tmp28);
            ExprValue tmp30 = evs1;
            tmp30.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp29, tmp30);
            // End Binary operator: >
            boolean tmp31 = ( tmp29.getIntValue() != 0 );
            if ( tmp31 ) {
                { // Invoke: set range_before [...]
                    TclObject tmp32;
                    { // Invoke: list $inscript_len $before_len
                        TclObject tmp33 = TclList.newInstance();
                        TclObject tmp34;
                        try {
                            tmp34 = getVarScalar(interp, "inscript_len", compiledLocals, 6);
                            TclList.append(interp, tmp33, tmp34);
                            tmp34 = getVarScalar(interp, "before_len", compiledLocals, 9);
                            TclList.append(interp, tmp33, tmp34);
                        } catch (TclException ex) {
                            tmp33.release();
                            throw ex;
                        }
                        interp.setResult(tmp33);
                    } // End Invoke: list
                    tmp32 = interp.getResult();
                    setVarScalar(interp, "range_before", tmp32, compiledLocals, 10);
                } // End Invoke: set
                { // Invoke: set range_before_string [...]
                    TclObject tmp35;
                    { // Invoke: parse getstring $inscript $range_before
                        TclObject[] objv36 = TJC.grabObjv(interp, 4);
                        TclObject tmp37;
                        try {
                            // Arg 0 constant: parse
                            objv36[0] = const3;
                            // Arg 1 constant: getstring
                            objv36[1] = const4;
                            // Arg 2 variable: $inscript
                            tmp37 = getVarScalar(interp, "inscript", compiledLocals, 4);
                            tmp37.preserve();
                            objv36[2] = tmp37;
                            // Arg 3 variable: $range_before
                            tmp37 = getVarScalar(interp, "range_before", compiledLocals, 10);
                            tmp37.preserve();
                            objv36[3] = tmp37;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv36, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp37 = objv36[2];
                            if ( tmp37 != null ) {
                                tmp37.release();
                            }
                            tmp37 = objv36[3];
                            if ( tmp37 != null ) {
                                tmp37.release();
                            }
                            TJC.releaseObjv(interp, objv36, 4);
                        }
                    } // End Invoke: parse
                    tmp35 = interp.getResult();
                    setVarScalar(interp, "range_before_string", tmp35, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: append ... $range_before_string
                    TclObject[] objv38 = TJC.grabObjv(interp, 1);
                    TclObject tmp39;
                    try {
                        // Arg 2 variable: $range_before_string
                        tmp39 = getVarScalar(interp, "range_before_string", compiledLocals, 11);
                        tmp39.preserve();
                        objv38[0] = tmp39;
                        interp.resetResult();
                        appendVarArray(interp, "_parseproc", "outscript", objv38, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv38, 1);
                    }
                } // End Invoke: append
                { // Invoke: if {$debug} ...
                    TclObject tmp40 = getVarScalar(interp, "debug", compiledLocals, 3);
                    boolean tmp41 = TJC.getBoolean(interp, tmp40);
                    if ( tmp41 ) {
                        { // Invoke: puts "..."
                            TclObject[] objv42 = TJC.grabObjv(interp, 2);
                            TclObject tmp43;
                            try {
                                // Arg 0 constant: puts
                                objv42[0] = const1;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp44 = new StringBuffer(64);
                                sbtmp44.append("range_before is ");
                                sbtmp44.append("{");
                                tmp43 = getVarScalar(interp, "range_before", compiledLocals, 10);
                                sbtmp44.append(tmp43.toString());
                                sbtmp44.append("}");
                                tmp43 = TclString.newInstance(sbtmp44);
                                tmp43.preserve();
                                objv42[1] = tmp43;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv42, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp43 = objv42[1];
                                if ( tmp43 != null ) {
                                    tmp43.release();
                                }
                                TJC.releaseObjv(interp, objv42, 2);
                            }
                        } // End Invoke: puts
                        { // Invoke: puts "..."
                            TclObject[] objv45 = TJC.grabObjv(interp, 2);
                            TclObject tmp46;
                            try {
                                // Arg 0 constant: puts
                                objv45[0] = const1;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp47 = new StringBuffer(64);
                                sbtmp47.append("range_before_string is ");
                                sbtmp47.append("\"");
                                tmp46 = getVarScalar(interp, "range_before_string", compiledLocals, 11);
                                sbtmp47.append(tmp46.toString());
                                sbtmp47.append("\"");
                                tmp46 = TclString.newInstance(sbtmp47);
                                tmp46.preserve();
                                objv45[1] = tmp46;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv45, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp46 = objv45[1];
                                if ( tmp46 != null ) {
                                    tmp46.release();
                                }
                                TJC.releaseObjv(interp, objv45, 2);
                            }
                        } // End Invoke: puts
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: set ... [...]
            TclObject tmp48;
            { // Invoke: list $inscript_start [...]
                TclObject tmp49 = TclList.newInstance();
                TclObject tmp50;
                try {
                    tmp50 = getVarScalar(interp, "inscript_start", compiledLocals, 5);
                    TclList.append(interp, tmp49, tmp50);
                    { // Invoke: expr ...
                        // Binary operator: $range_start + $range_len
                        TclObject tmp51 = getVarScalar(interp, "range_start", compiledLocals, 7);
                        ExprValue tmp52 = evs0;
                        TJC.exprInitValue(interp, tmp52, tmp51);
                        TclObject tmp53 = getVarScalar(interp, "range_len", compiledLocals, 8);
                        ExprValue tmp54 = evs1;
                        TJC.exprInitValue(interp, tmp54, tmp53);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp52, tmp54);
                        // End Binary operator: +
                        TJC.exprSetResult(interp, tmp52);
                    } // End Invoke: expr
                    tmp50 = interp.getResult();
                    TclList.append(interp, tmp49, tmp50);
                } catch (TclException ex) {
                    tmp49.release();
                    throw ex;
                }
                interp.setResult(tmp49);
            } // End Invoke: list
            tmp48 = interp.getResult();
            setVarArray(interp, "_parseproc", "inscript_range", tmp48, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if {$debug} ...
            TclObject tmp55 = getVarScalar(interp, "debug", compiledLocals, 3);
            boolean tmp56 = TJC.getBoolean(interp, tmp55);
            if ( tmp56 ) {
                { // Invoke: puts "..."
                    TclObject[] objv57 = TJC.grabObjv(interp, 2);
                    TclObject tmp58;
                    try {
                        // Arg 0 constant: puts
                        objv57[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp59 = new StringBuffer(64);
                        sbtmp59.append("prev inscript_range is ");
                        sbtmp59.append("{");
                        tmp58 = getVarScalar(interp, "inscript_start", compiledLocals, 5);
                        sbtmp59.append(tmp58.toString());
                        sbtmp59.append(" ");
                        tmp58 = getVarScalar(interp, "inscript_len", compiledLocals, 6);
                        sbtmp59.append(tmp58.toString());
                        sbtmp59.append("}");
                        tmp58 = TclString.newInstance(sbtmp59);
                        tmp58.preserve();
                        objv57[1] = tmp58;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv57, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp58 = objv57[1];
                        if ( tmp58 != null ) {
                            tmp58.release();
                        }
                        TJC.releaseObjv(interp, objv57, 2);
                    }
                } // End Invoke: puts
                { // Invoke: puts "..."
                    TclObject[] objv60 = TJC.grabObjv(interp, 2);
                    TclObject tmp61;
                    try {
                        // Arg 0 constant: puts
                        objv60[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp62 = new StringBuffer(64);
                        sbtmp62.append("command range is ");
                        sbtmp62.append("{");
                        tmp61 = getVarScalar(interp, "range_start", compiledLocals, 7);
                        sbtmp62.append(tmp61.toString());
                        sbtmp62.append(" ");
                        tmp61 = getVarScalar(interp, "range_len", compiledLocals, 8);
                        sbtmp62.append(tmp61.toString());
                        sbtmp62.append("}");
                        tmp61 = TclString.newInstance(sbtmp62);
                        tmp61.preserve();
                        objv60[1] = tmp61;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv60, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp61 = objv60[1];
                        if ( tmp61 != null ) {
                            tmp61.release();
                        }
                        TJC.releaseObjv(interp, objv60, 2);
                    }
                } // End Invoke: puts
                { // Invoke: puts "..."
                    TclObject[] objv63 = TJC.grabObjv(interp, 2);
                    TclObject tmp64;
                    try {
                        // Arg 0 constant: puts
                        objv63[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp65 = new StringBuffer(64);
                        sbtmp65.append("command string is ");
                        sbtmp65.append("\"");
                        { // Invoke: parse getstring $inscript [...]
                            TclObject[] objv66 = TJC.grabObjv(interp, 4);
                            TclObject tmp67;
                            try {
                                // Arg 0 constant: parse
                                objv66[0] = const3;
                                // Arg 1 constant: getstring
                                objv66[1] = const4;
                                // Arg 2 variable: $inscript
                                tmp67 = getVarScalar(interp, "inscript", compiledLocals, 4);
                                tmp67.preserve();
                                objv66[2] = tmp67;
                                // Arg 3 command: [...]
                                { // Invoke: list $range_start $range_len
                                    TclObject tmp68 = TclList.newInstance();
                                    TclObject tmp69;
                                    try {
                                        tmp69 = getVarScalar(interp, "range_start", compiledLocals, 7);
                                        TclList.append(interp, tmp68, tmp69);
                                        tmp69 = getVarScalar(interp, "range_len", compiledLocals, 8);
                                        TclList.append(interp, tmp68, tmp69);
                                    } catch (TclException ex) {
                                        tmp68.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp68);
                                } // End Invoke: list
                                tmp67 = interp.getResult();
                                tmp67.preserve();
                                objv66[3] = tmp67;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv66, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp67 = objv66[2];
                                if ( tmp67 != null ) {
                                    tmp67.release();
                                }
                                tmp67 = objv66[3];
                                if ( tmp67 != null ) {
                                    tmp67.release();
                                }
                                TJC.releaseObjv(interp, objv66, 4);
                            }
                        } // End Invoke: parse
                        tmp64 = interp.getResult();
                        sbtmp65.append(tmp64.toString());
                        sbtmp65.append("\"");
                        tmp64 = TclString.newInstance(sbtmp65);
                        tmp64.preserve();
                        objv63[1] = tmp64;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv63, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp64 = objv63[1];
                        if ( tmp64 != null ) {
                            tmp64.release();
                        }
                        TJC.releaseObjv(interp, objv63, 2);
                    }
                } // End Invoke: puts
                { // Invoke: puts "..."
                    TclObject[] objv70 = TJC.grabObjv(interp, 2);
                    TclObject tmp71;
                    try {
                        // Arg 0 constant: puts
                        objv70[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp72 = new StringBuffer(64);
                        sbtmp72.append("new outscript is ");
                        sbtmp72.append("\"");
                        tmp71 = getVarArray(interp, "_parseproc", "outscript", compiledLocals, 2);
                        sbtmp72.append(tmp71.toString());
                        sbtmp72.append("\"");
                        tmp71 = TclString.newInstance(sbtmp72);
                        tmp71.preserve();
                        objv70[1] = tmp71;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv70, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp71 = objv70[1];
                        if ( tmp71 != null ) {
                            tmp71.release();
                        }
                        TJC.releaseObjv(interp, objv70, 2);
                    }
                } // End Invoke: puts
                { // Invoke: puts "..."
                    TclObject[] objv73 = TJC.grabObjv(interp, 2);
                    TclObject tmp74;
                    try {
                        // Arg 0 constant: puts
                        objv73[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp75 = new StringBuffer(64);
                        sbtmp75.append("new inscript_range is ");
                        sbtmp75.append("{");
                        tmp74 = getVarArray(interp, "_parseproc", "inscript_range", compiledLocals, 2);
                        sbtmp75.append(tmp74.toString());
                        sbtmp75.append("}");
                        tmp74 = TclString.newInstance(sbtmp75);
                        tmp74.preserve();
                        objv73[1] = tmp74;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv73, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp74 = objv73[1];
                        if ( tmp74 != null ) {
                            tmp74.release();
                        }
                        TJC.releaseObjv(interp, objv73, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "_parseproc_append_outscript_including");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("puts");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("error");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("parse");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("getstring");
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "puts";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "parse";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "range",
        "_parseproc",
        "debug",
        "inscript",
        "inscript_start",
        "inscript_len",
        "range_start",
        "range_len",
        "before_len",
        "range_before",
        "range_before_string"
    };
} // end class ParseprocAppendOutscriptIncludingCmd

